/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.99 by edhill, Mon Sep 27 15:49:48 2004 UTC revision 1.174 by cnh, Thu Nov 6 03:55:50 2008 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -f Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
 %.$tfs : %.F  
135  .SUFFIXES:  .SUFFIXES:
136  genmake_hello.$tfs: genmake_hello.F  .SUFFIXES: .$tfs .F
137          $LN genmake_hello.F genmake_hello.$tfs  .F.$tfs:
138            $LN \$< \$@
139  EOF  EOF
140      $MAKE "genmake_hello."$tfs > /dev/null 2>&1      $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141      RETVAL=$?      RETVAL=$?
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -f Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 181  look_for_makedepend()  { Line 189  look_for_makedepend()  {
189      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
190          which makedepend > /dev/null 2>&1          which makedepend > /dev/null 2>&1
191          RV0=$?          RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201          cat <<EOF >> genmake_tc.f          cat <<EOF >> genmake_tc.f
202        program test        program test
203        write(*,*) 'test'        write(*,*) 'test'
# Line 189  look_for_makedepend()  { Line 206  look_for_makedepend()  {
206  EOF  EOF
207          makedepend genmake_tc.f > /dev/null 2>&1          makedepend genmake_tc.f > /dev/null 2>&1
208          RV1=$?          RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211          if test "x${RV0}${RV1}" = x00 ; then          if test "x${RV0}${RV1}" = x00 ; then
212              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
213          else          else
# Line 237  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 271  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 310  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 342  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 516  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 523  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 581  WARNING: Please contact <MITgcm-support@ Line 674  WARNING: Please contact <MITgcm-support@
674  EOF  EOF
675          return 1          return 1
676      fi      fi
677      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
678        subroutine tcall( string )        subroutine tcall( string )
679        character*(*) string        character*(*) string
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 653  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
750        echo $COMM >> genmake_warnings
751        $COMM >> genmake_warnings 2>&1
752      RET_C=$?      RET_C=$?
753      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
754        program hello        program hello
755        Real*8 wtime        REAL*8 wtime
756        external cloc        external cloc
757        call cloc(wtime)        call cloc(wtime)
758        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
759        end program hello        end
760  EOF  EOF
761      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
762        echo $COMM >> genmake_warnings
763        $COMM >> genmake_warnings 2>&1
764      RET_F=$?      RET_F=$?
765      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
766      RETVAL=$?      RETVAL=$?
767      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
768          HAVE_CLOC=t          HAVE_CLOC=t
# Line 675  EOF Line 772  EOF
772  }  }
773    
774    
775    check_HAVE_SIGREG()  {
776        if test ! "x$HAVE_SIGREG" = x ; then
777            return
778        fi
779        get_fortran_c_namemangling
780        cat <<EOF > genmake_tc_1.c
781    $FC_NAMEMANGLE
782    #include <stdlib.h>
783    #include <stdio.h>
784    #include <signal.h>
785    #include <errno.h>
786    #include <ucontext.h>
787    
788    int * ip;
789    
790    static void killhandler(
791        unsigned int sn, siginfo_t  si, struct ucontext *sc )
792    {
793        *ip = *ip + 1;
794        return;
795    }
796    
797    void FC_NAMEMANGLE(sigreg) (int * aip)
798    {
799        struct sigaction s;
800        ip = aip;
801        s.sa_flags = SA_SIGINFO;
802        s.sa_sigaction = (void *)killhandler;
803        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
804            printf("Sigaction returned error = %d\n", errno);
805            exit(0);
806        }
807        return;
808    }
809    EOF
810        COMM="$CC $CFLAGS -c genmake_tc_1.c"
811        echo $COMM >> genmake_warnings
812        $COMM >> genmake_warnings 2>&1
813        RET_C=$?
814        cat <<EOF > genmake_tc_2.$FS
815          program hello
816          integer anint
817          common /iv/ anint
818          external sigreg
819          call sigreg(anint)
820          end
821    EOF
822        echo >> genmake_warnings
823        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
824        cat genmake_tc_2.$FS >> genmake_warnings
825        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
826        echo $COMM >> genmake_warnings
827        $COMM >> genmake_warnings 2>&1
828        RETVAL=$?
829        if test "x$RETVAL" = x0 ; then
830            HAVE_SIGREG=t
831            DEFINES="$DEFINES -DHAVE_SIGREG"
832        fi
833        rm -f genmake_tc*
834    }
835    
836    
837    check_HAVE_SETRLSTK()  {
838        if test "x$HAVE_SETRLSTK" = xt ; then
839            DEFINES="$DEFINES -DHAVE_SETRLSTK"
840            return
841        fi  
842        if test ! "x$HAVE_SETRLSTK" = x ; then
843            return
844        fi
845        get_fortran_c_namemangling
846        cat <<EOF > genmake_tc_1.c
847    $FC_NAMEMANGLE
848    #include <sys/time.h>
849    #include <sys/resource.h>
850    #include <unistd.h>
851    void FC_NAMEMANGLE(setrlstk) ()
852    {
853        struct rlimit rls;
854        rls.rlim_cur = RLIM_INFINITY;
855        rls.rlim_max = RLIM_INFINITY;
856        setrlimit(RLIMIT_STACK, &rls);
857        return;
858    }
859    EOF
860        COMM="$CC $CFLAGS -c genmake_tc_1.c"
861        echo $COMM >> genmake_warnings
862        $COMM >> genmake_warnings 2>&1
863        RET_C=$?
864        cat <<EOF > genmake_tc_2.$FS
865          program hello
866          external setrlstk
867          call setrlstk()
868          end
869    EOF
870        echo >> genmake_warnings
871        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
872        cat genmake_tc_2.$FS >> genmake_warnings
873        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
874        echo $COMM >> genmake_warnings
875        $COMM >> genmake_warnings 2>&1
876        RETVAL=$?
877        if test "x$RETVAL" = x0 ; then
878            HAVE_SETRLSTK=t
879            DEFINES="$DEFINES -DHAVE_SETRLSTK"
880        fi
881        rm -f genmake_tc*
882    }
883    
884    
885    check_HAVE_STAT()  {
886        get_fortran_c_namemangling
887        cat <<EOF > genmake_tc_1.c
888    $FC_NAMEMANGLE
889    #include <stdio.h>
890    #include <stdlib.h>
891    #include <unistd.h>
892    #include <sys/stat.h>
893    #include <sys/types.h>
894    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
895    {
896        char name[512];
897        struct stat astat;
898    
899        name[0] = 'a'; name[1] = '\0';
900        if (! stat(name, &astat))
901            *nbyte = (int)(astat.st_size);
902        else
903            *nbyte = -1;
904    }
905    EOF
906        COMM="$CC $CFLAGS -c genmake_tc_1.c"
907        echo $COMM >> genmake_warnings
908        $COMM >> genmake_tc.log 2>&1
909        RET_C=$?
910        cat <<EOF > genmake_tc_2.$FS
911          program hello
912          integer nbyte
913          call tfsize(nbyte)
914          print *," HELLO WORLD", nbyte
915          end
916    EOF
917        echo >> genmake_warnings
918        echo "running: check_HAVE_STAT()" >> genmake_warnings
919        cat genmake_tc_2.$FS >> genmake_warnings
920        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
921        echo $COMM >> genmake_warnings
922        $COMM >> genmake_tc.log 2>&1
923        RETVAL=$?
924        if test "x$RETVAL" = x0 ; then
925            HAVE_STAT=t
926            DEFINES="$DEFINES -DHAVE_STAT"
927        fi
928        rm -f genmake_tc*
929    }
930    
931    
932  check_netcdf_libs()  {  check_netcdf_libs()  {
933      echo "" > genmake_tnc.log      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
934      cat <<EOF > genmake_tnc.for          return
935        fi
936        echo >> genmake_warnings
937        echo "running: check_netcdf_libs()" >> genmake_warnings
938        cat <<EOF > genmake_tnc.F
939        program fgennc        program fgennc
940  #include "netcdf.inc"  #include "netcdf.inc"
941    EOF
942        if test ! "x$MPI" = x ; then
943            echo '#include "mpif.h"' >> genmake_tnc.F
944        fi
945        cat <<EOF >> genmake_tnc.F
946        integer iret, ncid, xid        integer iret, ncid, xid
947        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
948        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 689  check_netcdf_libs()  { Line 952  check_netcdf_libs()  {
952        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
953        end        end
954  EOF  EOF
955      #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
956      #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"      cat genmake_tnc.F >> genmake_tnc.log
957      #echo "$LINK -o genmake_tnc.o $LIBS"      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
958      $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \      RET_CPP=f
959          &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
960          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1      echo "$COMM" >> genmake_tnc.log
961        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
962        if test "x$RET_CPP" = xf ; then
963            echo "  WARNING: CPP failed to pre-process the netcdf test." \
964                >> genmake_tnc.log
965            echo "    Please check that \$INCLUDES is properly set." \
966                >> genmake_tnc.log
967        fi
968        echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
969        echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
970        $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
971            &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
972      RET_COMPILE=$?      RET_COMPILE=$?
973        cat genmake_tnc.log >> genmake_warnings
974    
975      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
976      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 708  EOF Line 983  EOF
983          HAVE_NETCDF=t          HAVE_NETCDF=t
984      else      else
985          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
986          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
987              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
988              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
989            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
990            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
991                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
992                &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
993          RET_COMPILE=$?          RET_COMPILE=$?
994            cat genmake_tnc.log >> genmake_warnings
995          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
996              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
997              HAVE_NETCDF=t              HAVE_NETCDF=t
998          else          else
999            # try again with "-lnetcdff" added to the libs
1000                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1001                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1002                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1003                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1004                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
1005                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
1006                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1007                RET_COMPILE=$?
1008              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1009                if test "x$RET_COMPILE" = x0 ; then
1010                    LIBS="$LIBS -lnetcdff -lnetcdf"
1011                    HAVE_NETCDF=t
1012                fi
1013          fi          fi
1014      fi      fi
1015      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 735  PLATFORM= Line 1028  PLATFORM=
1028  LN=  LN=
1029  S64=  S64=
1030  KPP=  KPP=
1031  FC=  #FC=
1032  #CC=gcc  #CC=gcc
1033  CPP=  #CPP=
1034  LINK=  LINK=
1035  DEFINES=  DEFINES=
1036  PACKAGES=  PACKAGES=
1037  ENABLE=  ENABLE=
1038  DISABLE=  DISABLE=
1039  MAKEFILE=  # MAKEFILE=
1040  #MAKEDEPEND=  # MAKEDEPEND=
1041  PDEPEND=  PDEPEND=
1042  DUMPSTATE=t  DUMPSTATE=t
1043  PDEFAULT=  PDEFAULT=
1044  OPTFILE=  OPTFILE=
1045  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
1046  FFLAGS=  FFLAGS=
1047  FOPTIM=  FOPTIM=
1048    FEXTRAFLAGS=
1049  CFLAGS=  CFLAGS=
1050  KFLAGS1=  KFLAGS1=
1051  KFLAGS2=  KFLAGS2=
# Line 762  NOOPTFILES= Line 1056  NOOPTFILES=
1056  NOOPTFLAGS=  NOOPTFLAGS=
1057  MPI=  MPI=
1058  MPIPATH=  MPIPATH=
1059    TS=
1060    PAPIS=
1061    PCLS=
1062    FOOLAD=
1063    PAPI=
1064    PCL=
1065    HPMT=
1066    GSL=
1067    DEVEL=
1068    HAVE_TEST_L=
1069    
1070  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1071  HAVE_SYSTEM=  HAVE_SYSTEM=
1072  HAVE_FDATE=  HAVE_FDATE=
1073  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1074  HAVE_CLOC=  HAVE_CLOC=
1075    # HAVE_SETRLSTK=
1076    HAVE_STAT=
1077  HAVE_NETCDF=  HAVE_NETCDF=
1078  HAVE_ETIME=  HAVE_ETIME=
1079    IGNORE_TIME=
1080    
1081  MODS=  MODS=
1082  TOOLSDIR=  TOOLSDIR=
# Line 780  STANDARDDIRS="USE_THE_DEFAULT" Line 1087  STANDARDDIRS="USE_THE_DEFAULT"
1087  G2ARGS=  G2ARGS=
1088  BASH=  BASH=
1089  PWD=`pwd`  PWD=`pwd`
1090  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1091  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1092    EMBED_SRC=
1093  THISHOST=`hostname`  THISHOST=`hostname`
1094  THISCWD=`pwd`  THISCWD=`pwd`
1095  THISDATE=`date`  THISDATE=`date`
# Line 815  TAMC_EXTRA= Line 1123  TAMC_EXTRA=
1123    
1124  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1125  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1126  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1127    
1128  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1129  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1130  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1131  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1132  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 845  EOF Line 1153  EOF
1153    
1154  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1155  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1156  printf "  getting local config information:  "  printf "  getting local config information:  "
1157  if test -f $gm_local ; then  if test -f $gm_local ; then
1158      echo "using $gm_local"      echo "using $gm_local"
# Line 861  else Line 1163  else
1163      echo "none found"      echo "none found"
1164  fi  fi
1165    
1166  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1167  #OPTIONS=  #OPTIONS=
1168  #n=0  #n=0
1169  #for i ; do  #for i ; do
# Line 873  fi Line 1175  fi
1175  #done  #done
1176  #parse_options  #parse_options
1177  ac_prev=  ac_prev=
1178  for ac_option in $@ ; do  for ac_option in "$@" ; do
1179    
1180      G2ARGS="$G2ARGS \"$ac_option\""      G2ARGS="$G2ARGS \"$ac_option\""
1181    
# Line 995  for ac_option in $@ ; do Line 1297  for ac_option in $@ ; do
1297          -noieee | --noieee)          -noieee | --noieee)
1298              IEEE= ;;              IEEE= ;;
1299    
1300            -ts | --ts)
1301                TS=true ;;
1302            -papis | --papis)
1303                PAPIS=true ;;
1304            -pcls | --pcls)
1305                PCLS=true ;;
1306            -foolad | --foolad)
1307                FOOLAD=true ;;
1308            -papi | --papi)
1309                PAPI=true ;;
1310            -pcl | --pcl)
1311                PCL=true ;;
1312            -hpmt | --hpmt)
1313                HPMT=true ;;
1314    
1315            -gsl | --gsl)
1316                GSL=true ;;
1317    
1318            -devel | --devel)
1319                DEVEL=true ;;
1320    
1321          -mpi | --mpi)          -mpi | --mpi)
1322              MPI=true ;;              MPI=true ;;
1323          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1018  for ac_option in $@ ; do Line 1341  for ac_option in $@ ; do
1341              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1342          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1343              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1344            
1345            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1346                IGNORE_TIME="-DIGNORE_TIME" ;;
1347    
1348            -es | --es | -embed-source | --embed-source)
1349                EMBED_SRC=t ;;
1350    
1351          -*)          -*)
1352              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 1033  for ac_option in $@ ; do Line 1362  for ac_option in $@ ; do
1362            
1363  done  done
1364    
1365    
1366  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1367      echo      echo
1368      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1369      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1370      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1371      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1372      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1373      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1374      echo      echo
1375  fi  fi
1376    
1377  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1378  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1379      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1380      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1381          ROOTDIR=".."          ROOTDIR=".."
1382      else      else
1383          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1074  fi Line 1403  fi
1403    
1404  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1405  if test -f "${ROOTDIR}/doc/tag-index" ; then  if test -f "${ROOTDIR}/doc/tag-index" ; then
1406      THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1407    fi
1408    
1409    if test "x$MAKEFILE" = x ; then
1410        MAKEFILE="Makefile"
1411  fi  fi
1412    
1413  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
# Line 1106  if test "x$OPTFILE" != xNONE ; then Line 1439  if test "x$OPTFILE" != xNONE ; then
1439      fi      fi
1440  fi  fi
1441    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1442  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1443  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1444      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1136  if test "x${AD_OPTFILE}" != xNONE ; then Line 1466  if test "x${AD_OPTFILE}" != xNONE ; then
1466      fi      fi
1467  fi  fi
1468    
1469    #====================================================================
1470    #  Set default values if not set by the optfile
1471    #
1472  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1473  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1474  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
# Line 1212  Error: The command "ln -s" failed -- ple Line 1545  Error: The command "ln -s" failed -- ple
1545  EOF  EOF
1546      exit 1      exit 1
1547  fi  fi
1548    test -L genmake_tlink > /dev/null 2>&1
1549    RETVAL=$?
1550    if test "x$RETVAL" = x0 ; then
1551        HAVE_TEST_L=t
1552    fi
1553  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1554    
1555  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1222  if test ! "x$MPI" = x ; then Line 1560  if test ! "x$MPI" = x ; then
1560        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1561  fi  fi
1562    
1563    if test ! "x$TS" = x ; then
1564          echo "  Turning on timing per timestep"
1565          if test ! "x$FOOLAD" = x ; then
1566                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1567          else
1568                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1569          fi
1570          PACKAGES="$PACKAGES showflops"
1571    fi
1572    if test ! "x$PAPIS" = x ; then
1573          echo "  Turning on PAPI flop summary per timestep"
1574          echo "  Please make sure PAPIINC, PAPILIB are defined"
1575          if test ! "x$FOOLAD" = x ; then
1576                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1577          else
1578                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1579          fi
1580          INCLUDES="$INCLUDES $PAPIINC"
1581          LIBS="$LIBS $PAPILIB"
1582          PACKAGES="$PACKAGES showflops"
1583    fi
1584    if test ! "x$PCLS" = x ; then
1585          echo "  Turning on PCL counter summary per timestep"
1586          echo "  Please make sure PCLINC, PCLLIB are defined"
1587          if test ! "x$FOOLAD" = x ; then
1588                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1589          else
1590                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1591          fi
1592          INCLUDES="$INCLUDES $PCLINC"
1593          LIBS="$LIBS $PCLLIB"
1594          PACKAGES="$PACKAGES showflops"
1595    fi
1596    if test ! "x$PAPI" = x ; then
1597          if test ! "x$PAPIS" = x ; then
1598              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1599              echo "  Sticking with PAPI flop summary per timestep!"
1600          else
1601              echo "  Turning on performance analysis with PAPI"
1602              echo "  Please make sure PAPIINC, PAPILIB are defined"
1603              DEFINES="$DEFINES -DUSE_PAPI"
1604              INCLUDES="$INCLUDES $PAPIINC"
1605              LIBS="$LIBS $PAPILIB"
1606          fi
1607    fi
1608    if test ! "x$PCL" = x ; then
1609          if test ! "x$PCLS" = x ; then
1610              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1611              echo "  Sticking with PCL flop summary per timestep!"
1612          else
1613              echo "  Turning on performance analysis with PCL"
1614              echo "  Please make sure PCLINC, PCLLIB are defined"
1615              DEFINES="$DEFINES -DUSE_PCL"
1616              INCLUDES="$INCLUDES $PCLINC"
1617              LIBS="$LIBS $PCLLIB"
1618          fi
1619    fi
1620    if test ! "x$HPMT" = x ; then
1621          if test ! "x$PAPI" = x ; then
1622              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1623              echo "  Sticking with PAPI!"
1624          else if test ! "x$PCL" = x ; then
1625              echo "  PCL and the HPM Toolkit cannot co-exist!"
1626              echo "  Sticking with PCL!"
1627          else
1628              echo "  Turning on performance analysis with the HPM Toolkit"
1629              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1630              DEFINES="$DEFINES -DUSE_LIBHPM"
1631              INCLUDES="$INCLUDES $HPMTINC"
1632              LIBS="$LIBS $HPMTLIB"
1633          fi
1634          fi
1635    fi
1636    if test ! "x$GSL" = x ; then
1637          echo "  Turning on use of GSL to control floating point calculations"
1638          echo "  Please make sure GSLINC, GSLLIB are defined"
1639          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1640          INCLUDES="$INCLUDES $GSLINC"
1641          LIBS="$LIBS $GSLLIB"
1642    fi
1643    
1644  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1645  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1646  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1647        program hello        program hello
1648        call system('echo hi')        call system('echo hi')
1649        end        end
1650  EOF  EOF
1651  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1652  RETVAL=$?  RETVAL=$?
1653  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1654      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1242  fi Line 1661  fi
1661  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1662    
1663  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1664  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1665        program hello        program hello
1666        CHARACTER(128) string        CHARACTER*(128) string
1667        string = ' '        string = ' '
1668        call fdate( string )        call fdate( string )
1669        print *, string        print *, string
1670        end        end
1671  EOF  EOF
1672  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1673  RETVAL=$?  RETVAL=$?
1674  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1675      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1263  fi Line 1682  fi
1682  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1683    
1684  printf "  Do we have the etime() command using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1685  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1686        program hello        program hello
1687        REAL*4 ACTUAL, TARRAY(2)        REAL*4 ACTUAL, TARRAY(2)
1688        EXTERNAL ETIME        EXTERNAL ETIME
# Line 1272  cat > genmake_tcomp.f <<EOF Line 1691  cat > genmake_tcomp.f <<EOF
1691        print *, tarray        print *, tarray
1692        end        end
1693  EOF  EOF
1694  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1695  RETVAL=$?  RETVAL=$?
1696  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1697      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1290  if test "x$HAVE_CLOC" != x ; then Line 1709  if test "x$HAVE_CLOC" != x ; then
1709      echo "yes"      echo "yes"
1710  else  else
1711      echo "no"      echo "no"
1712        if test "x$EMBED_SRC" = xt ; then
1713            echo "    WARNING: you requested file embedding but it has"
1714            echo "      been disabled since C code cannot be called"
1715            EMBED_SRC=
1716        fi
1717    fi
1718    rm -f genmake_t*
1719    
1720    printf "  Can we unlimit the stack size using $FC...  "
1721    check_HAVE_SETRLSTK
1722    if test "x$HAVE_SETRLSTK" = xt ; then
1723        echo "yes"
1724    else
1725        echo "no"
1726    fi
1727    rm -f genmake_t*
1728    
1729    printf "  Can we register a signal handler using $FC...  "
1730    check_HAVE_SIGREG
1731    if test "x$HAVE_SIGREG" = xt ; then
1732        echo "yes"
1733    else
1734        echo "no"
1735    fi
1736    rm -f genmake_t*
1737    
1738    printf "  Can we use stat() through C calls...  "
1739    check_HAVE_STAT
1740    if test "x$HAVE_STAT" != x ; then
1741        echo "yes"
1742    else
1743        echo "no"
1744  fi  fi
1745  rm -f genmake_t*  rm -f genmake_t*
1746    
# Line 1300  if test "x$HAVE_NETCDF" != x ; then Line 1751  if test "x$HAVE_NETCDF" != x ; then
1751  else  else
1752      echo "no"      echo "no"
1753  fi  fi
1754    DEFINES="$DEFINES $IGNORE_TIME"
1755    
1756    if test "x$EMBED_SRC" = xt ; then
1757        build_embed_encode
1758    fi
1759    if test "x$EMBED_SRC" = xt ; then
1760        ENABLE="$ENABLE embed_files"
1761    fi
1762    
1763    
1764  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 1317  for d in $MODS ; do Line 1776  for d in $MODS ; do
1776  done  done
1777  echo  echo
1778    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1779  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1780      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1781  fi  fi
1782    
1783  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1784      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1785      if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1786          EXEDIR=../exe          EXEDIR=../exe
1787      else      else
# Line 1345  if test ! -d ${TOOLSDIR} ; then Line 1801  if test ! -d ${TOOLSDIR} ; then
1801      exit 1      exit 1
1802  fi  fi
1803  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1804      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1805        RETVAL=$?
1806        if test "x${RETVAL}" = x0 ; then
1807            S64='$(TOOLSDIR)/set64bitConst.sh'
1808        else
1809            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1810            RETVAL=$?
1811            if test "x${RETVAL}" = x0 ; then
1812                S64='$(TOOLSDIR)/set64bitConst.csh'
1813            else
1814                cat <<EOF
1815    
1816    ERROR: neither of the two default scripts:
1817    
1818        ${TOOLSDIR}/set64bitConst.sh
1819        ${TOOLSDIR}/set64bitConst.csh
1820    
1821      are working so please check paths or specify (with \$S64) a
1822      working version of this script.
1823    
1824    EOF
1825                exit 1
1826            fi
1827        fi
1828  fi  fi
1829  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1830    
# Line 1367  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1846  if test -r $ROOTDIR"/eesupp/src/Makefile
1846      fi      fi
1847  fi  fi
1848    
1849  #same for exch2  #same for pkg/exch2 and pkg/regrid
1850  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1851      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1852      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1853      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1854      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1855          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1856      else              rm -f make_${pdir}.errors
1857          echo "Error: problem encountered while building source files in exch2:"          else
1858          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1859          exit 1              cat make_${pdir}.errors 1>&2
1860                exit 1
1861            fi
1862      fi      fi
1863  fi  done
1864    
1865  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1866  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1490  done Line 1971  done
1971  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1972  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1973    
1974    #  Check for package MNC: if NetCDF is available, then build the MNC
1975    #  template files ; otherwise, delete mnc from the list of packages.
1976    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1977    RETVAL=$?
1978    if test "x$RETVAL" = x0 ; then
1979        if test "x$HAVE_NETCDF" != xt ; then
1980            cat <<EOF
1981    
1982    *********************************************************************
1983    WARNING: the "mnc" package was enabled but tests failed to compile
1984      NetCDF applications.  Please check that:
1985    
1986      1) NetCDF is correctly installed for this compiler and
1987      2) the LIBS variable (within the "optfile") specifies the correct
1988           NetCDF library to link against.
1989    
1990      Due to this failure, the "mnc" package is now DISABLED.
1991    *********************************************************************
1992    
1993    EOF
1994            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1995            DISABLE="$DISABLE mnc"
1996        else
1997            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1998            RETVAL=$?
1999            if test "x${RETVAL}" = x0 ; then
2000                rm -f make_mnc.errors
2001            else
2002                echo "Error: problem encountered while building source files in pkg/mnc:"
2003                cat make_mnc.errors 1>&2
2004                exit 1
2005            fi
2006        fi
2007    fi
2008    
2009    #  Check for package PROFILES: if NetCDF is not available,
2010    #  then delete profiles from the list of available packages.
2011    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2012    RETVAL=$?
2013    if test "x$RETVAL" = x0 ; then
2014        if test "x$HAVE_NETCDF" != xt ; then
2015            cat <<EOF
2016    
2017    *********************************************************************
2018    WARNING: the "profiles" package was enabled but tests failed to
2019      compile NetCDF applications.  Please check that:
2020    
2021      1) NetCDF is correctly installed for this compiler and
2022      2) the LIBS variable (within the "optfile") specifies the correct
2023           NetCDF library to link against.
2024    
2025      Due to this failure, the "profiles" package is now DISABLED.
2026    *********************************************************************
2027    
2028    EOF
2029            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2030            DISABLE="$DISABLE profiles"
2031        fi
2032    fi
2033    
2034  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2035  ck=  ck=
2036  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2037      i=0      i=0
2038      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2039      rtot=$nname      rtot=$nname
2040      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2041    
2042          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2043          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1530  while test "x$ck" != xtt ; do Line 2071  while test "x$ck" != xtt ; do
2071    
2072          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2073          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2074                #echo "   " $pname ": need to add :" $dname
2075              in_dis="f"              in_dis="f"
2076              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2077                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1574  for i in $PACKAGES ; do Line 2116  for i in $PACKAGES ; do
2116      fi      fi
2117  done  done
2118    
 #  Build MNC templates and check for ability to build and use NetCDF  
 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" = x0 ; then  
     ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         rm -f make_mnc.errors  
     else  
         echo "Error: problem encountered while building source files in pkg/mnc:"  
         cat make_mnc.errors 1>&2  
         exit 1  
     fi  
     if test "x$HAVE_NETCDF" != xt ; then  
         cat <<EOF  
   
 *********************************************************************  
 WARNING: the "mnc" package was enabled but tests failed to compile  
   NetCDF applications.  Please check that:  
   
   1) NetCDF is correctly installed for this compiler and  
   2) the LIBS variable (within the "optfile") specifies the correct  
        NetCDF library to link against.  
   
   Due to this failure, the "mnc" package is now DISABLED.  
 *********************************************************************  
   
 EOF  
         temp=`echo $PACKAGES | sed -e 's/mnc//g'`  
         PACKAGES=$temp  
     fi  
 fi  
   
2119  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
2120  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
2121  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1626  for n in $names ; do Line 2135  for n in $names ; do
2135              fi              fi
2136          done          done
2137          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
2138              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2139              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2140          fi          fi
2141      fi      fi
2142  done  done
2143  ENABLED_PACKAGES=  ENABLED_PACKAGES=
2144  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2145      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2146      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2147  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
2148    
# Line 1707  fi Line 2216  fi
2216    
2217  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
2218  #  compiler.  #  compiler.
2219  if test -f ./ad_files ; then  if test -f ./adSrcFiles.tmp ; then
2220      rm -f ./ad_files      rm -f ./adSrcFiles.tmp
2221  fi  fi
2222  echo "  Creating the list of files for the adjoint compiler."  echo "  Creating the list of files for the adjoint compiler."
2223  for i in $SOURCEDIRS ; do  for i in $SOURCEDIRS ; do
2224      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2225      for j in $list_files ; do      for j in $list_files ; do
2226          cat $i/$j >> ad_files          cat $i/$j >> adSrcFiles.tmp
2227      done      done
2228  done  done
2229    if test ! "x"$FS = "x.f" ; then
2230        cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2231        mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2232    fi
2233    
2234  echo  echo
2235  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1728  for i in $INCLUDEDIRS ; do Line 2240  for i in $INCLUDEDIRS ; do
2240      fi      fi
2241  done  done
2242    
2243    if test ! "x$DIVA" = x ; then
2244        echo "  Creating the pseudo-MPI include directory"
2245        INCLUDES="-I./mpi_headers $INCLUDES"
2246        rm -rf ./mpi_headers
2247        mkdir -p ./mpi_headers
2248    
2249        if test "x$MPIINCLUDEDIR" = x ; then
2250            if test "x$MPIHOME" = x ; then
2251                MPIHOME='/usr'
2252            fi
2253            MPIINCLUDEDIR='$MPIHOME/include'
2254        fi
2255        
2256        if test -r $MPIINCLUDEDIR/mpif.h ; then
2257            for i in $MPI_HEADER_FILES; do
2258                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2259            done
2260    
2261            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2262        else
2263            echo " We cannot create a copy of mpif.h!"
2264    #       exit -1
2265        fi
2266    fi
2267    
2268  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2269  rm -rf .links.tmp  rm -rf .links.tmp
2270  mkdir .links.tmp  mkdir .links.tmp
2271    touch .links.tmp/foo
2272    if test ! -r ".links.tmp/foo" ; then
2273        echo
2274        echo "ERROR : something is wrong with your directory permissions or"
2275        echo "   your user file-creation mask (\"umask\") since creating a"
2276        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2277        echo "   not working.  Please try setting your umask to something"
2278        echo "   sane such as:"
2279        echo
2280        echo "      umask 0002"
2281        echo
2282        echo "   and please verify that you have the proper permissions for"
2283        echo "   creating sub-directories and then reading files created"
2284        echo "   within them."
2285        echo
2286        exit 1
2287    fi
2288    rm -f .links.tmp/foo
2289    
2290    if test "x$OPENAD" != x ; then
2291        OAD_DONT_COMPILE="/dev/null"
2292        OAD_DONT_TRANSFORM="/dev/null"
2293        OAD_KEEP_ORIGINAL="/dev/null"
2294        OAD_CB2M_FILES="/dev/null"
2295        echo "  looking for dontCompile file:  "
2296        for i in "." $MODS ; do
2297            if test -r $i"/dontCompile" ; then
2298                OAD_DONT_COMPILE=$i"/dontCompile"
2299                echo "     found $OAD_DONT_COMPILE"
2300                break
2301            fi
2302        done
2303        echo "  looking for dontTransform file:  "
2304        for i in "." $MODS ; do
2305            if test -r $i"/dontTransform" ; then
2306                OAD_DONT_TRANSFORM=$i"/dontTransform"
2307                echo "     found $OAD_DONT_TRANSFORM"
2308                break
2309            fi
2310        done
2311        echo "  looking for keepOriginal file:  "
2312        for i in "." $MODS ; do
2313            if test -r $i"/keepOriginal" ; then
2314                OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2315                echo "     found $OAD_KEEP_ORIGINAL"
2316                break
2317            fi
2318        done
2319        echo "  looking for cb2mFiles:  "
2320        for i in "." $MODS ; do
2321            if test -r $i"/cb2mFiles" ; then
2322                OAD_CB2M_FILES=$i"/cb2mFiles"
2323                echo "     found $OAD_CB2M_FILES"
2324                break
2325            fi
2326        done
2327        echo "   OpenAD exceptions:  "
2328    fi
2329    
2330  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2331  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2332  printf 'SRCFILES = '    > srclist.inc  printf 'F77_SRC_FILES = ' > F77srclist.tmp
2333  printf 'CSRCFILES = '   > csrclist.inc  printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2334  printf 'F90SRCFILES = ' > f90srclist.inc  printf 'C_SRC_FILES = '   > csrclist.tmp
2335  printf 'HEADERFILES = ' > hlist.inc  printf 'F90_SRC_FILES = ' > F90srclist.tmp
2336  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'H_SRC_FILES = '   > hsrclist.tmp
2337    printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2338  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2339  for d in $alldirs ; do  for d in $alldirs ; do
2340      deplist=      deplist=
2341      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2342      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2343        if test "x$OPENAD" != x ; then
2344            sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2345        fi
2346      for sf in $sfiles ; do      for sf in $sfiles ; do
2347          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2348              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2349                    ignore_f=f
2350                  case $d/$sf in                  case $d/$sf in
2351                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2352                            ignore_f=t
2353                          ;;                          ;;
2354                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2355                            ignore_f=t
2356                          ;;                          ;;
2357                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2358                            ignore_f=t
2359                          ;;                          ;;
2360                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2361                            ignore_f=t
2362                            ;;
2363                      ./EMBEDDED_FILES.h)
2364                            ignore_f=t
2365                          ;;                          ;;
2366                    *)                    *)
2367                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2368                          deplist="$deplist $sf"                          #  ignore all soft-links
2369                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2370                                ignore_f=t
2371                            else
2372                                touch .links.tmp/$sf
2373                                deplist="$deplist $sf"
2374                            fi
2375                          ;;                          ;;
2376                  esac                  esac
2377                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2378                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2379                      F)                      case $extn in
2380                          echo    " \\"  >> srclist.inc                        F)
2381                          printf " $sf" >> srclist.inc                          echo    " \\"  >> F77srclist.tmp
2382                            printf " $sf" >> F77srclist.tmp
2383                            if test "x$OPENAD" != x ; then
2384                                basename=${sf%%.F}
2385                                isAD=`egrep ^$basename.f'[  ]*' adSrcFiles.tmp`
2386                                if test -z "$isAD" ; then
2387                                    toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE}`
2388                                    if test -z "$toBeIgnored" ; then
2389                                        echo    " \\"  >> nonADF77srclist.tmp
2390                                        printf " $sf" >> nonADF77srclist.tmp
2391                                    else
2392                                        echo "    not to be compiled   :  $sf"
2393                                    fi
2394                                else # file is initially listed as an AD file we want to exclude it
2395                                     # or we want to retain the untransformed version
2396                                    notToBeTransformed=`egrep ^$basename'[      ]*' ${OAD_DONT_TRANSFORM}`
2397                                    untransformedVersionToBeKept=`egrep ^$basename'[      ]*' ${OAD_KEEP_ORIGINAL}`
2398                                    if test -n "$notToBeTransformed"; then
2399                                        echo "    not to be transformed:  $sf"
2400                                    fi
2401                                    if test -n "$untransformedVersionToBeKept" ; then
2402                                        echo "    original to be kept  :  $sf"
2403                                    fi    
2404                                    if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2405                                        echo    " \\"  >> nonADF77srclist.tmp
2406                                        printf " $sf" >> nonADF77srclist.tmp
2407                                    fi
2408                                fi
2409                            fi
2410                          ;;                          ;;
2411                      F90)                      F90)
2412                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> F90srclist.tmp
2413                          printf " $sf" >> f90srclist.inc                          printf " $sf" >> F90srclist.tmp
2414                          ;;                          ;;
2415                      c)                      c)
2416                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.tmp
2417                          printf " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.tmp
2418                          ;;                          ;;
2419                      h)                      h)
2420                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hsrclist.tmp
2421                          printf " $sf" >> hlist.inc                          printf " $sf" >> hsrclist.tmp
2422                          ;;                          ;;
2423                      flow)                      flow)
2424                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.tmp
2425                          printf " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.tmp
2426                          ;;                          ;;
2427                  esac                     esac
2428                    fi
2429              fi              fi
2430          fi          fi
2431      done      done
2432      if test "x$deplist" != x ; then      if test "x$deplist" != x ; then
2433          echo "" >> srclinks.tmp        if test "$d" != "." ; then
2434            echo "" >> srclinks.tmp
2435          echo "#  These files are linked from $d" >> srclinks.tmp          echo "#  These files are linked from $d" >> srclinks.tmp
2436          echo "$deplist :" >> srclinks.tmp          echo "$deplist :" >> srclinks.tmp
2437          printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp  # We need to make sure that the link isn't already there.
2438    # This may happen when make thinks that a header file has to be "remade"
2439    # because a module it depends on has changed.  In this case we do nothing.
2440            printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2441          fi
2442      fi      fi
2443  done  done
2444  rm -rf .links.tmp  rm -rf .links.tmp
2445  echo "" >> srclist.inc  echo "" >> F77srclist.tmp
2446  echo "" >> csrclist.inc  echo "" >> nonADF77srclist.tmp
2447  echo "" >> f90srclist.inc  echo "" >> csrclist.tmp
2448  echo "" >> hlist.inc  echo "" >> F90srclist.tmp
2449  echo "" >> ad_flow_files.inc  echo "" >> hsrclist.tmp
2450    echo "" >> ad_flow_files.tmp
2451    
2452  if test -f $MAKEFILE ; then  if test -f $MAKEFILE ; then
2453      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 1858  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2507  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2507    
2508  # These files are created by Makefile  # These files are created by Makefile
2509  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2510  EOF  EOF
2511    
2512  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2513        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2514    else
2515        echo "EMBEDDED_FILES = " >>$MAKEFILE
2516    fi
2517    
2518    #  Note: figure out some way to add Hyades JAM libraries here
2519  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2520  # Unix ln (link)  # Unix ln (link)
2521  LN = ${LN}  LN = ${LN}
# Line 1889  INCLUDES = ${INCLUDES} Line 2542  INCLUDES = ${INCLUDES}
2542  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2543  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2544  # Optim./debug for FC  # Optim./debug for FC
2545  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2546  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2547  # Optim./debug for FC  # Optim./debug for FC
2548  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
2549  F90OPTIM = ${F90OPTIM}  F90OPTIM = ${F90OPTIM}
2550    F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2551  # Flags for CC  # Flags for CC
2552  CFLAGS = ${CFLAGS}  CFLAGS = ${CFLAGS}
2553  # Files that should not be optimized  # Files that should not be optimized
2554  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
2555  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
2556  # Flags and libraries needed for linking  # Flags and libraries needed for linking
2557  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2558  # Name of the Mekfile  # Name of the Mekfile
2559  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2560    
2561  EOF  EOF
2562    
2563  cat srclist.inc       >> $MAKEFILE  cat F77srclist.tmp      >> $MAKEFILE
2564  cat csrclist.inc      >> $MAKEFILE  cat nonADF77srclist.tmp >> $MAKEFILE
2565  cat f90srclist.inc    >> $MAKEFILE  cat csrclist.tmp        >> $MAKEFILE
2566  cat hlist.inc         >> $MAKEFILE  cat F90srclist.tmp      >> $MAKEFILE
2567  cat ad_flow_files.inc >> $MAKEFILE  cat hsrclist.tmp        >> $MAKEFILE
2568    cat ad_flow_files.tmp   >> $MAKEFILE
2569    
2570    rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2571    
2572  echo >> $MAKEFILE  echo >> $MAKEFILE
2573  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  
2574  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  # add definitions for preprocessed sources
2575  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  # and note that not all systems allow case sensitive extensions
2576    # hence the $FS and $FS90 here.
2577    # for fixed format f90 files we use ff90 or FF90 resp
2578    # but these are not expected to be the original source files
2579    
2580    echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')'      >> $MAKEFILE
2581    echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2582    echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2583    echo 'FLOFILES =  $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2584  echo >> $MAKEFILE  echo >> $MAKEFILE
2585  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
2586  echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE  echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  
 rm -f ad_flow_files.inc  
2587    
2588  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2589    
2590  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2591  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2592          @echo Creating \$@ ...          @echo Creating \$@ ...
2593          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2594  depend:  depend:
2595          @make links          @make links
2596          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2597          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2598          -rm -f makedepend.out          -rm -f makedepend.out
2599    
2600  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  lib: libmitgcmuv.a
2601    
2602    libmitgcmuv.a: \$(OBJFILES)
2603            ar rcv libmitgcmuv.a \$(OBJFILES)
2604            ar d   libmitgcmuv.a main.o
2605    
2606    links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2607    
2608  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2609    
2610  output.txt: \$(EXECUTABLE)  output.txt: \$(EXECUTABLE)
2611          @printf 'running ... '          @printf 'running ... '
2612          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2613    
2614  clean:  clean:
2615          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2616            -rm -rf *.o
2617            -rm -rf *.$FS *.flowdir
2618            -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2619            -rm -rf temp.sed reslice.dat
2620  Clean:  Clean:
2621          @make clean          @make clean
2622          @make cleanlinks          @make cleanlinks
2623          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2624          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2625            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2626  CLEAN:  CLEAN:
2627          @make Clean          @make Clean
2628          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2629          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2630          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2631          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2632            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2633            -rm -rf mnc_test_*
2634    
2635  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2636  makefile:  makefile:
# Line 1961  makefile: Line 2638  makefile:
2638  cleanlinks:  cleanlinks:
2639          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2640    
2641  # Special targets (SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are created by make
2642  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2643          @echo Creating \$@ ...          @echo Creating \$@ ...
2644          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 1981  test ! "x$THISUSER" = x && echo "      -echo Line 2658  test ! "x$THISUSER" = x && echo "      -echo
2658  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2659  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2660    
2661    if test "x$EMBED_SRC" = xt ; then
2662        cat >>$MAKEFILE <<EOF
2663    
2664    decode_files.o : EMBEDDED_FILES.h
2665    
2666    ##  \$(F77_PP_SRC_FILES)
2667    all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2668            @echo Creating \$@ ...
2669            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2670            -rm -f all_fF.tar.gz
2671            -gzip all_fF.tar
2672    
2673    EMBEDDED_FILES.h : all_fF.tar.gz
2674            @echo Creating \$@ ...
2675            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2676    
2677    EOF
2678    fi
2679    
2680  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2681    
2682  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
2683    
2684    ## This nullifies any default implicit rules concerning these two file types:
2685  %.o : %.F  %.o : %.F
2686    
2687  .F.$FS:  .F.$FS:
# Line 1993  cat >>$MAKEFILE <<EOF Line 2690  cat >>$MAKEFILE <<EOF
2690          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2691  .F90.$FS90:  .F90.$FS90:
2692          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2693    .FF90.f$FS90:
2694            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2695  .$FS90.o:  .$FS90.o:
2696          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2697    .f$FS90.o:
2698            cp \$< \$(basename  \$<).f90
2699            \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename  \$<).f90
2700  .c.o:  .c.o:
2701          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2702    .flow.flowdir:
2703            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2704    
2705  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2706  .F.p:  .F.p:
# Line 2004  cat >>$MAKEFILE <<EOF Line 2708  cat >>$MAKEFILE <<EOF
2708  .p.$FS:  .p.$FS:
2709          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2710    
2711    EOF
2712    
2713  #=========================================  #=========================================
2714  #===  Automatic Differentiation Rules  ===  #===  Automatic Differentiation Rules  ===
2715    #===  for TAMC/TAF  ======================
2716    
2717    if test "x$OPENAD" == x ; then
2718    
2719    cat >>$MAKEFILE <<EOF
2720    
2721  TAMC           = ${TAMC}  TAMC           = ${TAMC}
2722  TAF            = ${TAF}  TAF            = ${TAF}
# Line 2020  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2731  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2731  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2732  for i in $ad_vars ; do  for i in $ad_vars ; do
2733      name=$i      name=$i
2734      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2735      eval $t1      eval $t1
2736      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2737      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2738  done  done
2739    
2740  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2040  rm -f ad_files Line 2751  rm -f ad_files
2751  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2752    
2753  # ... AD ...  # ... AD ...
2754  adall: ad_taf  adall: \$(EXE_AD)
2755  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2756  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2757    
2758  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2759          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2760          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2761          -rm -f ad_config.template          -rm -f ad_config.template
2762          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2763          @make \$(AD_FLOW_FILES)          @make \$(FLOFILES)
2764          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2765    
2766  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2767          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2768          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          ls -l ad_input_code_ad.$FS
2769            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2770    
2771  adtafonly:  adtafonly:
2772          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2773          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          ls -l ad_input_code_ad.$FS
2774            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2775  ad_taf: ad_taf_output.o \$(OBJFILES)  
2776          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2777            \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2778  ad_tamc_output.f: ad_input_code.f  
2779          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2780          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2781            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2782    
2783  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2784          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2785    
2786    adonlyfwd:
2787            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2788    
2789    adtrick:
2790            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2791    
2792  # ... FTL ...  # ... FTL ...
2793  ftlall: ftl_taf  ftlall: ftl_taf
2794  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2795  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2796    
2797  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2798          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2799          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2800          -rm -f ftl_config.template          -rm -f ftl_config.template
2801          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2802          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2803          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2804    
2805  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2806          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2807          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          ls -l ftl_input_code_ftl.$FS
2808            cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2809    
2810  ftltafonly:  ftltafonly:
2811          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2812          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          ls -l ftl_input_code_ftl.$FS
2813            cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2814    
2815  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2816          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2817    
2818  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2819          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2820          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2821    
2822  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2823          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2824    
2825    
2826  # ... SVD ...  # ... SVD ...
2827  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2828  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2829            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2830    svdall: svd_touch svd_taf
2831    
2832  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2833          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2834    
2835            @echo "--->>> Only COMPILE svd code! <<<---"
2836            @echo "--->>> Assumes you previously <<<---"
2837            @echo "--->>> did make svdtaf        <<<---"
2838    
2839    svd_touch:
2840            @echo "--->>> Only COMPILE svd code! <<<---"
2841            @echo "--->>> Assumes you previously <<<---"
2842            @echo "--->>> did make svdtaf        <<<---"
2843            touch ad_taf_output.$FS ftl_taf_output.$FS
2844            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2845            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2846            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2847            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2848            -rm -f ftl_config.template
2849    
2850  #=========================================  EOF
2851    
2852    fi
2853    
2854    #===  for OpenAD  ========================
2855    
2856    if test "x$OPENAD" != x ; then
2857    
2858    # ============ begin OpenAD specific section ==============
2859    
2860    cat >>$MAKEFILE <<EOF
2861    
2862    # all the source files linked from the various locations:
2863    ALL_LINKED_FILES= \
2864    \$(F77_SRC_FILES) \
2865    \$(C_SRC_FILES) \
2866    \$(H_SRC_FILES) \
2867    \$(F90_SRC_FILES) \
2868    \$(SPECIAL_FILES)
2869    
2870    ifndef OPENADROOT
2871      \$(error "Error:  environment variable OPENADROOT not defined!")
2872    endif
2873    
2874    ifndef XAIFSCHEMAROOT
2875      \$(error "Error:  environment variable XAIFSCHEMAROOT not defined!")
2876    endif
2877    
2878    ifndef XAIFBOOSTERROOT
2879      \$(error "Error:  environment variable XAIFBOOSTERROOT not defined!")
2880    endif
2881    
2882    EOF
2883    
2884    echo "  Add the source list for common block to module conversion "
2885    echo >> $MAKEFILE
2886    printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2887    for i in `cat ${OAD_CB2M_FILES}` ; do
2888      echo    " \\" >> $MAKEFILE
2889      printf " $i" >> $MAKEFILE
2890    done
2891    echo >> $MAKEFILE
2892    
2893    echo "  Add the source list for AD code generation"
2894    echo >> $MAKEFILE
2895    printf "AD_FILES = " >> $MAKEFILE
2896    for i in `cat ${OAD_CB2M_FILES}` ; do
2897      echo    " \\" >> $MAKEFILE
2898      printf " ${i}_mod.f$FS90" >> $MAKEFILE
2899    done
2900    AD_FILES=`cat adSrcFiles.tmp`
2901    for i in $AD_FILES ; do
2902      basename=${i%%.f}
2903      toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2904      if test -z "$toBeIgnored" ; then
2905        echo    " \\" >> $MAKEFILE
2906        printf " $i" >> $MAKEFILE
2907      fi
2908    done
2909    echo >> $MAKEFILE
2910    rm -f adSrcFiles.tmp
2911    
2912    cat >>$MAKEFILE <<EOF
2913    
2914    adAll: \$(EXE_AD)
2915    .PHONY: adAll
2916    
2917    CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2918    
2919    .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2920    
2921    .PHONY: adDepend
2922    adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2923            \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2924            \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2925            -rm -f makedepend.out
2926    
2927    OPENAD_SUPPORT_F90_SRC_FILES = \
2928    w2f__types.F90 \
2929    OAD_active.F90 \
2930    OAD_cp.F90 \
2931    OAD_rev.F90 \
2932    OAD_tape.F90        
2933    
2934    OPENAD_SUPPORT_C_SRC_FILES = \
2935    iaddr.c \
2936    timeRatio.c
2937    
2938    f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2939            cat \$^ > \$@
2940    
2941    f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90
2942            cat \$^ > \$@
2943    
2944    f95_test.out: f95_test_mods.f90 f95_test.f90
2945            f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
2946            f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
2947    
2948    AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o  ad_input_code.w2f.canon.xb.x2w.w2f.rs.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
2949    
2950    \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
2951            @echo Creating \$@ ...
2952            \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
2953    
2954    # makefile debug rule
2955    openad: ad_input_code.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90
2956    .PHONY: openad
2957    
2958    # create the module files
2959    %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
2960            ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
2961    
2962    # create the header files
2963    %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
2964            ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
2965    
2966    # change everybody else to use the new module files:
2967    %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
2968            ../OAD_support/cb2mUseModules.bash $< ${MPI}
2969    
2970    # makefile debug rule
2971    small_f: \$(CB2M_F90_PP_SRC_FILES)
2972    .PHONY: small_f
2973    
2974    ad_output.txt: \$(EXE_AD)
2975            @printf 'linking data files ... '
2976            \$(LN) -f ../input_ad/data* ../input_ad/eedata .
2977            \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
2978            @printf 'running ... '
2979            @./\$(EXE_AD) > \$@
2980    
2981    CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
2982    ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
2983            cat \$^ > \$@
2984    
2985    # strip all comments and blanks to reduce
2986    # the file size in order to reduce perl's memory requirements
2987    ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
2988            cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
2989    
2990    # mfef90 preprocessing
2991    # expand statement functions
2992    # expose mfef90 specific substring handling
2993    # add the w2f__types module
2994    ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
2995            ./mfef90 -r8 -z -F -N132 \$<
2996            mv \$<.B \$(basename \$<).B
2997            ./whirl2f -openad \$(basename \$<).B
2998            cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
2999    
3000    # canonicalizer
3001    ad_input_code_sf.w2f.canon.f$FS90: ad_input_code_sf.w2f.f$FS90 canon.v1.py
3002            python canon.v1.py --r8 \$< > \$@
3003    
3004    # F -> WHIRL
3005    # note that the canonicalized version cuts off at col 72
3006    # doing this also for string constants which is ok as long
3007    # as we are in fixed mode and cut of exactly there.
3008    # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3009    # characters respectively.
3010    ad_input_code_sf.w2f.canon.B: ad_input_code_sf.w2f.canon.f$FS90 mfef90
3011            ./mfef90 -r8 -z -F \$<
3012            mv \$<.B \$@
3013    
3014    # WHIRL -> XAIF
3015    ad_input_code_sf.w2f.canon.xaif : ad_input_code_sf.w2f.canon.B whirl2xaif
3016            ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3017    
3018    # XAIF -> XAIF'
3019    ad_input_code_sf.w2f.canon.xb.xaif : ad_input_code_sf.w2f.canon.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd openad_adm
3020            ./openad_adm -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3021    
3022    # XAIF' -> WHIRL'
3023    ad_input_code_sf.w2f.canon.xb.x2w.B : ad_input_code_sf.w2f.canon.xb.xaif xaif2whirl
3024            ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.canon.B \$<
3025    
3026    # WHIRL' -> F'
3027    ad_input_code_sf.w2f.canon.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.canon.xb.x2w.B whirl2f whirl2f_be
3028            ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3029    
3030    # undo slice hiding
3031    # insert template directives
3032    ad_input_code_sf.w2f.canon.xb.x2w.w2f.rs.f$FS90: ad_input_code_sf.w2f.canon.xb.x2w.w2f.f$FS90 reslicer.py ../OAD_support/insertTemplateDir.bash
3033            python reslicer.py \$< > \$<.1
3034            ../OAD_support/insertTemplateDir.bash \$<.1  \$@
3035            rm \$<.1
3036    
3037    # postprocess F'
3038    ad_input_code_sf.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90: ad_input_code_sf.w2f.canon.xb.x2w.w2f.rs.f$FS90 multi-pp.pl ../OAD_support/ad_inline.f \$(wildcard ../OAD_support/ad_template.*.f)
3039            perl multi-pp.pl -inline=../OAD_support/ad_inline.f \$<
3040            # the postprocessor still gets the name wrong
3041            cat \$<.pp | sed 's/RETURN//' > \$@
3042    
3043    # extract all transformed modules
3044    all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90
3045            cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3046    
3047    # remove the transformed globals module from the
3048    # transformed ad_input_code file
3049    # and remove for now the duplicate variables
3050    # and fix 2 data statements
3051    ad_input_code.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90: ad_input_code_sf.w2f.canon.xb.x2w.w2f.rs.pp.f$FS90
3052            cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^      INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3053    
3054    # setup some links
3055    %.xsd:
3056            \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3057    
3058    mfef90:
3059            \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3060    
3061    # link the support files:
3062    \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3063            \$(LN) ../OAD_support/\$@ .
3064    
3065    whirl2xaif xaif2whirl:
3066            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3067    
3068    %.pl:
3069            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3070    
3071    %.py:
3072            \$(LN) \${OPENADROOT}/OpenADFortTk/tools/canonicalize/\$@ .
3073    
3074    whirl2f whirl2f_be:
3075            \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3076    
3077    openad_adm:
3078            \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/test/t \$@
3079    
3080    # ============ end OpenAD specific section ==============
3081    
3082  EOF  EOF
3083    
3084    fi
3085    
3086    #=========================================
3087    
3088  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
3089      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3090  fi  fi

Legend:
Removed from v.1.99  
changed lines
  Added in v.1.174

  ViewVC Help
Powered by ViewVC 1.1.22